module ppu
(
    input               clock,
    output  reg  [3:0]  r,
    output  reg  [3:0]  g,
    output  reg  [3:0]  b,
    output              hs,
    output              vs
);
// ---------------------------------------------------------------------
assign hs = X < (48 + 640 + 16);
assign vs = Y < (33 + 480 + 10);
// ---------------------------------------------------------------------
reg  [10:0] X = 0;
reg  [ 9:0] Y = 0;
wire        xmax = (X == 799);
wire        ymax = (Y == 524);
wire [10:0] x    = (X - 48);
wire [ 9:0] y    = (Y - 33);
// ---------------------------------------------------------------------

always @(posedge clock) begin

    // Черный цвет вне окна
    {r, g, b} <= 12'h000;

    // Кадровая развертка
    X <= xmax ?         0 : X + 1;
    Y <= xmax ? (ymax ? 0 : Y + 1) : Y;

    // Вывод окна
    if (X >= 48 && X < 48 + 640 && Y >= 33 && Y < 33 + 480) {r, g, b} <= 12'h888;

end

endmodule
